/****
 *
 * Exemplo: Uso Incorreto de Variveis Locais de
 *          Durao Fixa
 *
 * Seo: D.4.5
 *
 ****/

#include <stdio.h>
#include <string.h>
#include <ctype.h>

#define TAM_ARRAY 50

/****
 *
 * StrEmMaiusculas(): Retorna um string correspondente ao
 *                    string recebido como parmetro com
 *                    todas as suas letras em maisculas
 *
 * Parmetro: str (entrada) - o string
 *
 * Retorno: Endereo do string correspondente ao string
 *          recebido como parmetro com todas as suas
 *          letras em maisculas. NULL, se o resultado no
 *          couber no array que o armazenaria.
 *
 ****/
char *StrEmMaiusculas(const char *str)
{
   static char maiusculas[TAM_ARRAY];
   char       *p;

      /* Verifica se o resultado caber no array */
   if (strlen(str) >= TAM_ARRAY)
      return NULL; /* No vai caber no array */

      /* Copia no array cada caractere do */
      /* string convertido por toupper()  */
   for (p = maiusculas; *p = toupper(*str); ++p, ++str) {
      ; /* Vazio */
   }

   return maiusculas;
}

int main(void)
{
   char *s1 = "Botafogo",
        *s2 = "Flamengo";

   printf( "\n\"%s\" em maiusculas: \"%s\"",
           s1, StrEmMaiusculas(s1) );
   printf( "\n\"%s\" em maiusculas: \"%s\"\n",
           s2, StrEmMaiusculas(s2) );

   return 0;
}

/******************* Exemplo de Execuo ******************

"Botafogo" em maiusculas: "BOTAFOGO"
"Flamengo" em maiusculas: "FLAMENGO"

**********************************************************/
