/****
 *
 * Exemplo: Passagem de Leitura para Escrita e Vice-versa
 *
 * Seo: D.6.11
 *
 ****/

#include <stdio.h>

int main(void)
{
   FILE *stream;

      /* Cria um novo arquivo de texto */
      /* em modo de atualizao        */
   if (!(stream = fopen("Teste", "w+"))) {
      printf("Arquivo nao foi aberto\n");
      return 1;
   }

      /* Escreve um string no arquivo */
   fprintf(stream, "AEIOU\n");

      /* Checa ocorrncia de erro */
   if (ferror(stream)) {
      printf("\nErro 1\n");
      return 1;
   }

      /* Volta ao incio do arquivo */
   rewind(stream);

      /* L um caractere e descarta-o */
   (void) fgetc(stream);

      /* Verifica se ocorreu erro de leitura */
   if (ferror(stream)) {
      printf("\nErro 2\n");
      return 1;
   }

      /* Tenta escrever um caractere no arquivo */
   fputc('X', stream);

      /* Verifica se ocorreu erro de escrita */
   if (ferror(stream)) {
      printf("\nErro 3\n");
      return 1;
   }

   fclose(stream); /* Fecha o arquivo */

   return 0;
}

/****************** Resultado do Programa ******************

O caractere 'X' NO  escrito no arquivo

***********************************************************/
