/****
 *
 * Exemplo: passing argument n of 'F' discards 'const'
 *          qualifier from pointer target type
 *
 * Seo: D.19.23
 *
 ****/

#include <stdio.h>

int F(int *p)
{
   printf("\n*p = %d\n", *p);

   return 0;
}

int main(void)
{
   const int varConstante = 0;

   printf("\nF() = %d\n", F(&varConstante));

   return 0;
}

/****************** Exemplo de Compilao ******************

warning: passing argument 1 of 'F' discards 'const' qualifier
from pointer target type

note: expected 'int *' but argument is of type 'const int *'

***********************************************************/
/****************** Resultado do Programa ******************

*p = 0

F() = 0

***********************************************************/
