/****
 *
 * Exemplo: Especificadores de printf()
 *
 * Seo: 3.14.1
 *
 * Descrio: Exibe na tela valores int e double em
 *            vrios formatos
 *
 ****/

#include <stdio.h>

int main(void)
{
   int    i1 = 40, i2 = 123;
   double x1 = 123.45, x2 = 123.456789;

   printf("\n\t>>> Especificador %%d: |%d|", i1);
   printf("\n\t>>> Especificador %%5d: |%5d|", i1);
   printf("\n\t>>> Especificador %%-5d: |%-5d|", i1);
   printf("\n\t>>> Especificador %%5.3d: |%5.3d|\n", i1);

   printf("\n\t>>> Especificador %%10.3f: |%10.3f|", x1);
   printf("\n\t>>> Especificador %%10.3e: |%10.3e|", x1);
   printf("\n\t>>> Especificador %%-10g: |%-10g|\n", x1);

   printf("\n\t>>> Formato padrao int (%%d): %d\n", i2);
   printf( "\t>>> Com especificador de precisao (%%2.8d): "
           "%2.8d\n", i2 );

   printf("\n\t>>> Formato padrao double (%%f): %f\n", x2);
   printf( "\t>>> Com especificador de precisao (%%-10.2f):"
           " %-10.2f\n", x2 );

  return 0;
}

/****************** Resultado do Programa *****************

        >>> Especificador %d: |40|
        >>> Especificador %5d: |   40|
        >>> Especificador %-5d: |40   |
        >>> Especificador %5.3d: |  040|

        >>> Especificador %10.3f: |   123.450|
        >>> Especificador %10.3e: |1.235e+002|
        >>> Especificador %-10g: |123.45    |

        >>> Formato padrao int (%d): 123
        >>> Com especificador de precisao (%2.8d): 00000123

        >>> Formato padrao double (%f): 123.456789
        >>> Com especificador de precisao (%-10.2f): 123.46

**********************************************************/
