/****
 *
 * Ttulo: Exponenciao
 *
 * Autor: Ulysses de Oliveira
 *
 * Data de Criao: 18/07/2012
 * ltima modificao: 18/07/2012
 *
 * Descrio: Calcula potenciaes de nmeros reais
 *            elevados a nmeros inteiros
 *
 * Entrada: A base e o expoente da exponenciao
 *
 * Sada: Uma mensagem apresentando o resultado da operao
 *
 ****/

#include <stdio.h>   /* printf()     */
#include "leitura.h" /* LeituraFacil */

/****
 *
 * main(): Calcula potenciaes de nmeros reais elevados
 *         a nmeros inteiros
 *
 * Parmetros: Nenhum
 *
 * Retorno: Zero
 *
 ****/
int main(void)
{
   int    exp, i;
   double base, resultado;

      /* Apresenta o programa */
   printf( "\n\t>>> Este programa calcula potenciacoes"
           "\n\t>>> de numeros reais elevados a numeros"
           "\n\t>>> inteiros. O programa encerra quando"
           "\n\t>>> o resultado for indefinido.\n" );

      /* O lao encerra quando o resultado for indefinido */
   while (1) {
         /* L o valor da base */
      printf( "\n\n\t>>> Digite o valor da base: " );
      base = LeReal();

         /* L o valor do expoente */
      printf( "\t>>> Digite o valor do expoente: " );
      exp = LeInteiro();

         /* Inicia a varivel que armazenar o resultado */
      resultado = 1;

         /* Se a base for zero e o expoente for menor do  */
         /* que ou igual a zero, o resultado  indefinido */
      if (!base && exp <= 0) {
         printf("\n\t>>> Resultado indefinido");
         break; /* Encerra o lao */
      } else if (!exp) {
            /* Se a base no for zero e o expoente */
            /* for zero o resultado  1            */
         printf("\n\t>>> Resultado: 1");
      } else if (exp > 0) {
            /* Se a base no for zero e o expoente for */
            /* positivo, multiplica a base o nmero de */
            /* vezes representado pelo expoente        */
         for (i = 1; i <= exp; i++) {
            resultado = resultado*base;
         }

         printf("\n\t>>> Resultado: %f", resultado);
      } else {

         /*                                        */
         /* Se a base no for zero e o expoente    */
         /* for negativo, calcula o resultado como */
         /* se o expoente fosse positivo e depois  */
         /* inverte o resultado                    */
         /*                                        */

         exp = -exp;

         for (i = 1; i <= exp; i++) {
            resultado = resultado*base;
         }

         printf("\n\t>>> Resultado: %f", 1/resultado);
      }
   } /* while */

      /* Despede-se do usurio */
   printf("\n\n\t>>> Obrigado por usar este programa.\n");

   return 0;
}

/******************* Exemplo de Execuo *******************

        >>> Este programa calcula potenciacoes
        >>> de numeros reais elevados a numeros
        >>> inteiros. O programa encerra quando
        >>> o resultado for indefinido.


        >>> Digite o valor da base: 2
        >>> Digite o valor do expoente: -3

        >>> Resultado: 0.125000

        >>> Digite o valor da base: 0
        >>> Digite o valor do expoente: 0

        >>> Resultado indefinido

        >>> Obrigado por usar este programa.

***********************************************************/
