/****
 *
 * Ttulo: Mnimo Mltiplo Comum (MMC)
 *
 * Autor: Ulysses de Oliveira
 *
 * Data de Criao: 16/09/2012
 * ltima modificao: 16/09/2012
 *
 * Descrio: Determina mnimo mltiplo comum (MMC) de dois
 *            nmeros inteiros positivos
 *
 * Entrada: Dois valores inteiros positivos
 *
 * Sada: O MMC dos dois nmero introduzidos
 *
 ****/

#include <stdio.h>   /* Entrada e sada */
#include "leitura.h" /* LeituraFacil    */

/****
 *
 * LeNatural(): L um nmero natural (i.e., um nmero
 *              inteiro no negativo)
 *
 * Parmetros: Nenhum
 *
 * Retorno: O nmero natural lido
 *
 ****/
int LeNatural(void)
{
   int numNatural; /* O nmero a ser lido */

inicio: /* Volta para c se o valor for invlido */
   numNatural = LeInteiro();

   while(numNatural < 0) {
      printf( "\a\n\t>>> Valor invalido. "
              "Tente novamente <<<\n\t> " );
      goto inicio; /* No faz mal a ningum */
   }

   return numNatural;
}

/****
 *
 * MMC(): Calcula o mnimo mltiplo comum de dois nmeros naturais
 *
 * Parmetros:
 *      a, b (entrada) - os dois nmeros usados no clculo
 *
 * Retorno: Zero, se um dos parmetros for menor do que ou igual
 *          a zero. O MMC dos dois parmetros, em caso contrrio.
 *
 ****/
int MMC(int a, int b)
{
   int n;

      /* Se um dos dois valores for menor do */
      /* que ou igual a zero, o MMC  zero   */
   if (a <= 0 || b <= 0) {
      return 0;
   }

      /* O MMC de a e b  um nmero entre 1 e a*b */
      /* que  divisvel tanto por a quanto por b */
   for(n = 1; n <= a*b; n++) {
      if(n%a == 0 && n%b == 0) {
         break; /* Encontrado o MMC */
      }
   }

   return n;
}

/****
 *
 * main(): Determina o MMC de dois nmeros naturais
 *
 * Parmetros: Nenhum
 *
 * Retorno: Zero
 *
 ****/
int main(void)
{
   int x, y;

      /* Apresenta o programa */
   printf( "\n\t>>> Este programa determina o minimo multiplo"
           "\n\t>>> comum de dois numeros inteiros.\n" );

   printf("\n\t>>> Digite um inteiro nao-negativo: ");
   x = LeNatural();

   printf("\t>>> Digite outro inteiro nao-negativo: ");
   y = LeNatural();

   printf("\n\t>>> MMC de %d e %d: %d\n", x, y, MMC(x, y));

   return 0;
}

/******************* Exemplo de Execuo ******************

       >>> Este programa determina o minimo multiplo
       >>> comum de dois numeros inteiros.

       >>> Digite um inteiro nao-negativo: 4
       >>> Digite outro inteiro nao-negativo: 6

       >>> MMC de 4 e 6: 12

**********************************************************/
