/****
 *
 * Ttulo: Leitura de Notas
 *
 * Autor: Ulysses de Oliveira
 *
 * Data de Criao: 17/05/2012
 * ltima modificao: 17/05/2012
 *
 * Descrio: L um valor x do tipo double tal que:
 *            0.0 <= x <= 10.0
 *
 * Entrada: Valores reais representando notas
 *
 * Sada: Mensagens indicando se a nota  vlida ou no
 *
 ****/

/*********************** Includes *************************/

#include <stdio.h>   /* printf() */
#include "leitura.h" /* LeReal() */

/***************** Definies de Funes ******************/

/****
 *
 * LeNota(): L um valor x do tipo double
 *           tal que: 0.0 <= x <= 10.0
 *
 * Parmetros: Nenhum
 *
 * Retorno: O valor lido
 *
 ****/
double LeNota(void)
{
   double valorLido;

      /* O lao while encerra apenas quando */
      /* for lido um valor vlido           */
   while (1) {
      valorLido = LeReal();

         /* Verifica se o valor lido est */
         /* de acordo com o esperado      */
      if (valorLido >= 0.0 && valorLido <= 10.0) {
         break; /* O valor lido est OK */
      } else {
         printf("\n\t>>> Nota incorreta. Tente novamente\n\t> ");
      }
   }

   return valorLido;
}

/****
 *
 * main(): Testa a funo LeNota()
 *
 * Parmetros: Nenhum
 *
 * Retorno: Zero
 *
 ****/
int main(void)
{
   double umaNota;

   printf("\n\t>>> Digite uma nota: ");
   umaNota = LeNota();

   printf( "\n\t>>> A nota introduzida foi %3.1f\n", umaNota );

   return 0;
}

/******************* Exemplo de Execuo *******************

        >>> Digite uma nota: -7

        >>> Nota incorreta. Tente novamente
        > 7

        >>> A nota introduzida foi 7.0

***********************************************************/
