/****
 *
 * Ttulo: Verificando Ordenao de Inteiros
 *
 * Autor: Ulysses de Oliveira
 *
 * Data de Criao: 23/06/2012
 * ltima modificao: 23/06/2012
 *
 * Descrio: Verifica se uma lista de nmeros inteiros
 *            est ordenada em ordem crescente
 *
 * Entrada: Valores inteiros introduzidos via teclado
 *
 * Sada: Uma mensagem indicando se os nmeros
 *        digitados esto em ordem crescente
 *
 ****/

#include <stdio.h>   /* printf()    */
#include "leitura.h" /* LeInteiro() */

/****
 *
 * main(): Verifica se uma lista de nmeros inteiros est
 *         ordenada em ordem crescente
 *
 * Parmetros: Nenhum
 *
 * Retorno: Zero
 *
 ****/
int main(void)
{
   int nValores, /* Nmero de valores introduzidos */
       valorCorrente, /* Armazena o valor corrente */
       valorAnterior, /* Armazena o valor anterior */
       emOrdem = 1, /* Informa se os valores esto */
                    /* em ordem crescente          */
       i;

      /* Apresenta o programa */
   printf( "\n\t>>> Este programa verifica se uma lista de N"
           "\n\t>>> numeros inteiros esta' em ordem crescente."
           "\n\t>>> O valor de N deve ser maior do que 1.\n" );

      /* L o nmero de valores a serem introduzidos. */
      /* Esse valor deve ser maior do que 1.          */
   while (1) {
         /* Tenta ler um valor correto */
      printf("\n\t>>> Digite o numero de valores: ");
      nValores = LeInteiro();

         /* Se o valor est correto, encerra o lao */
      if (nValores > 1) {
         break;
      }

         /* O valor no era o que o programa esperava */
      printf( "\nO numero de valores deve"
              " ser maior do que 1\n");
   }

      /* L o primeiro valor */
   printf("\n\t>>> Valor 1: ");
   valorAnterior = LeInteiro();

      /* L os demais valores. Para que eles estejam  */
      /* em ordem crescente, qualquer valor lido deve */
      /* ser maior do que ou igual ao anterior        */
   for (i = 2; i <= nValores; ++i) {
      printf("\n\t>>> Valor %d: ", i);
      valorCorrente = LeInteiro();

         /* Verifica se os valores esto em ordem crescente */
      if (valorCorrente < valorAnterior) {
         emOrdem = 0; /* Valores no esto em ordem */
         break; /* No adianta prosseguir */
      } else {
            /* At aqui, os valores esto em */
            /* ordem. Ento o valor anterior */
            /* passa a ser o valor corrente. */
         valorAnterior = valorCorrente;
      }
   }

      /* Apresenta o resultado */
   printf( "\n\t>>> Os valores %sestao em ordem "
           "crescente\n", emOrdem ? "" : "NAO " );

   return 0;
}

/******************* Exemplo de Execuo *******************

        >>> Este programa verifica se uma lista de N
        >>> numeros inteiros esta' em ordem crescente.
        >>> O valor de N deve ser maior do que 1.

        >>> Digite o numero de valores: 5

        >>> Valor 1: -5

        >>> Valor 2: 2

        >>> Valor 3: -4

        >>> Os valores NAO estao em ordem crescente

***********************************************************/
