/****
 *
 * Ttulo: Nmeros de Fibonacci I
 *
 * Autor: Ulysses de Oliveira
 *
 * Data de Criao: 03/06/2012
 * ltima modificao: 03/06/2012
 *
 * Descrio: Verifica se um numero introduzido pelo usurio
 *            faz parte de uma sequncia de Fibonacci.
 *
 * Entrada: Valores inteiros positivos
 *
 * Sada: Uma mensagem indicando se o nmero  primo ou no
 *
 ****/

#include <stdio.h>   /* printf()    */
#include "leitura.h" /* LeInteiro() */

/****
 *
 * main(): Verifica se um nmero lido via teclado faz parte de
 *         uma sequncia de Fibonacci
 *
 * Parmetros: Nenhum
 *
 * Retorno: Zero
 *
 ****/
int main(void)
{
   int antecedente1, antecedente2, atual, numeroTestado, i;

      /* Apresenta o programa */
   printf( "\n\t>>> Este programa verifica se um numero inteiro"
           "\n\t>>> positivo faz parte de uma sequencia de "
           "Fibonacci\n" );

      /* L o nmero que ser testado */
   while (1) {
      printf("\n>>> Digite o numero a ser testado:\n\t> ");
      numeroTestado = LeInteiro();

         /* Verifica se o valor  vlido */
      if (numeroTestado > 0) {
         break; /* Valor est OK */
      }

         /* Valor no  vlido */
      printf("\a\n\t>>> O numero deve ser maior do que 0 <<<\n");
   }

      /* Inicia os dois primeiros termos */
      /* e o termo atual da srie        */
   atual = antecedente1 = antecedente2 = 1;

      /* Gera os termos da seqncia a partir do */
      /* terceiro termo at encontrar um nmero  */
      /* maior ou igual ao nmero sendo testado  */
   for(i = 3; atual < numeroTestado; ++i) {
      atual = antecedente1 + antecedente2;

         /* Atualiza os termos antecedentes */
      antecedente1 = antecedente2;
      antecedente2 = atual;
   }

      /* Apresenta o resultado do teste. Se o ltimo      */
      /* nmero gerado for igual ao nmero sendo testado, */
      /* este faz parte de uma sequncia de Fibonacci.    */
   printf( "\n\t>>> %d %s e' um numero de Fibonacci\n",
           numeroTestado, numeroTestado == atual ? "" : "NAO" );

   return 0;
}

/******************* Exemplo de Execuo *******************

        >>> Este programa verifica se um numero inteiro
        >>> positivo faz parte de uma sequencia de Fibonacci

>>> Digite o numero a ser testado:
        > 5

        >>> 5  e' um numero de Fibonacci

***********************************************************/
