/****
 *
 * Exemplo: Uso de arrays como parmetros
 *
 * Seo: 7.9.2
 *
 ****/

#include <stdio.h>

void ExibeArrayDoubles(const double ar[], int tamanho)
{
   int  i;

   for (i = 0; i < tamanho; i++) {
      printf("ar[%d] = %3.1f\n", i, ar[i]);
   }
}

double MediaArrayDoubles(const double notas[], int numNotas)
{
   int    i;
   double soma = 0.0;

   for (i = 0; i < numNotas; i++) {
      soma = soma + notas[i];
   }

   return soma / numNotas;
}

int main(void)
{
   double notas[] = {5.2, 6.6, 8.0, 4.0, 5.5, 4.8, 9.1},
          m;

   printf("\n\n****** Notas ******\n\n");
   ExibeArrayDoubles(notas, sizeof(notas)/sizeof(notas[0]));

   m = MediaArrayDoubles(notas, sizeof(notas)/sizeof(notas[0]));
   printf("\nMedia da turma: %3.2f\n", m);

   return 0;
}

/****************** Resultado do Programa ******************

****** Notas ******

ar[0] = 5.2
ar[1] = 6.6
ar[2] = 8.0
ar[3] = 4.0
ar[4] = 5.5
ar[5] = 4.8
ar[6] = 9.1

Media da turma: 6.17

***********************************************************/
