/****
 *
 * Ttulo: Ocorrncias de Valores num Array
 *
 * Autor: Ulysses de Oliveira
 *
 * Data de Criao: 13/06/2012
 * ltima modificao: 13/06/2012
 *
 * Descrio: Determina o nmero de ocorrncias
 *            de cada elemento de um array
 *
 * Entrada: Valores inteiros introduzidos via teclado
 *
 *
 * Sada: V. exemplo de execuo
 *
 ****/

#include <stdio.h>   /* printf()    */
#include "leitura.h" /* LeInteiro() */

   /* Nmero mximo de elementos armazenados */
   /* no array usado pelo programa           */
#define MAX_ELEMENTOS 100

/****
 *
 * Ocorrencias(): Conta o nmero de ocorrncias de um
 *                nmero inteiro num array de inteiros
 *
 * Parmetros: ar[] (entrada): o array que ser pesquisado
 *             tam (entrada): nmero de elementos do array
 *             num (entrada): o nmero que ser procurado
 *
 * Retorno: O nmero de ocorrncias do nmero no array
 *
 ****/
int Ocorrencias(const int ar[], int tam, int num)
{
   int i,
       ocorr = 0; /* Conta o nmero de ocorrncia */

      /* Acessa cada elemento do array e compara-o com 'num'. */
      /* Se forem iguais, incrementa o nmero de ocorrncias. */
   for (i = 0; i < tam; ++i) {
      if (ar[i] == num) { /* Mais uma ocorrncia */
         ++ocorr; /* Incrementa o nmero de ocorrncias */
      }
   }

   return ocorr;
}

/****
 *
 * main(): Determina o nmero de ocorrncias de cada
 *         valor de elemento de um array de inteiros
 *
 * Parmetros: Nenhum
 *
 * Retorno: Zero
 *
 ****/
int main(void)
{
   int i, ar[MAX_ELEMENTOS], nElementos, nOcor;

      /* Apresenta o programa */
   printf( "\n\t>>> Este programa determina o numero de "
           "ocorrencias \n\t>>> de cada elemento de um array"
           " de inteiros\n" );

   /****************************************************/
   /* L o nmero de elementos que sero introduzidos. */
   /* Se esse valor for menor do que MAX_ELEMENTOS,    */
   /* apenas parte do array ar[] ser usada.           */
   /****************************************************/

   printf( "\nDigite o numero de elementos do array "
           "(min = 2, max = %d):\n\t> ", MAX_ELEMENTOS);

      /* O lao encerra quando for lido um valor maior do */
      /* que 1 e menor do que ou igual a MAX_ELEMENTOS    */
   while (1) {
      nElementos = LeInteiro();

      if (nElementos > 1 && nElementos <= MAX_ELEMENTOS) {
         break;
      } else {
         printf( "\nO valor deve estar entre 2 e %d\n\t> ",
                 MAX_ELEMENTOS );
      }
   }

      /* >>> L os elementos <<< */

   printf("\nIntroduza os elementos do array\n");

   for (i = 0; i < nElementos; ++i) {
      printf("\t%d> ", i + 1); /* Prompt */
      ar[i] = LeInteiro(); /* Leitura */
   }

      /* Conta o nmero de ocorrncias de cada elemento */
   for (i = 0; i < nElementos; ++i) {
      nOcor = Ocorrencias(ar, nElementos, ar[i]);
      printf( "\n\t>>> O numero %d aparece %d vez%s",
              ar[i], nOcor, nOcor > 1 ? "es" : "" );
   }

   return 0;
}

/******************* Exemplo de Execuo *******************

        >>> Este programa determina o numero de ocorrencias
        >>> de cada elemento de um array de inteiros

Digite o numero de elementos do array (min = 2, max = 100):
        > 6

Introduza os elementos do array
        1> -1
        2> 2
        3> 2
        4> 1
        5> 3
        6> -1

        >>> O numero -1 aparece 2 vezes
        >>> O numero 2 aparece 2 vezes
        >>> O numero 2 aparece 2 vezes
        >>> O numero 1 aparece 1 vez
        >>> O numero 3 aparece 1 vez
        >>> O numero -1 aparece 2 vezes

***********************************************************/

