/****
 *
 * Exemplo: Comparao de Strings: strcmp()
 *
 * Seo: 8.5.6
 *
 ****/

#include <stdio.h>
#include <string.h>

/****
 *
 * ClassificaStrings(): Compara strings usando strcmp() e
 *                      exibe o resultado na tela
 *
 * Parmetros:
 *      s1, s2 (entrada) - strings que sero comparados
 *
 * Retorno: Nada
 *
 ****/
void ClassificaStrings(const char *s1, const char *s2)
{
   int   compara;

      /* Obtm o resultado da comparao de s1 e s2 */
   compara = strcmp(s1, s2);

      /* Apresenta o resultado da comparao */
   if (!compara) {
      printf("\n\"%s\" e \"%s\" sao iguais", s1, s2);
   } else {
      printf( "\n\"%s\" %s \"%s\"", s1,
              compara < 0 ? "precede" : "sucede", s2 );
   }
}

int main(void)
{
      /* Chama ClassificaStrings() para apresentar  */
      /* resultados de comparao de vrios strings */
   ClassificaStrings("copo", "corpo");
   ClassificaStrings("Carol", "Carolina");
   ClassificaStrings("Maria", "maria");
   ClassificaStrings("Zebra", "abelha");
   ClassificaStrings("Jos", "Joo");
   ClassificaStrings("Bola", "Bola");
   ClassificaStrings("Maria", "Carol");

   return 0;
}

/****************** Resultado do Programa *****************

"copo" precede "corpo"
"Carol" precede "Carolina"
"Maria" precede "maria"
"Zebra" precede "abelha"
"Jos" precede "Joo"
"Bola" e "Bola" sao iguais
"Maria" sucede "Carol"

**********************************************************/
