/****
 *
 * Exemplo: Classificao de Caracteres: isalpha()
 *
 * Seo: 8.7.1
 *
 ****/

#include <ctype.h>
#include <stdio.h>

/****
 * EhStringAlfabetico(): Checa se um string contm apenas letras
 *
 * Parmetros: str (entrada) - o string a ser checado
 *
 * Retorno: 1, se o string for alfabtico; 0, em caso contrrio
 ****/
int EhStringAlfabetico(const char *str)
{
      /* O lao while  encerrado quando um caractere  */
      /* que no  letra  encontrado (inclusive '\0') */
   while (isalpha(*str++))
      ; /* Vazio */

      /* Faz 'str' apontar para o caractere */
      /* que causou o encerramento do lao  */
   --str;

      /* Se todos os caracteres so alfabticos, 'str' */
      /* est apontando para o caractere '\0'. Nesse   */
      /* caso, !*str resulta em 1. Caso contrrio,     */
      /* 'str' est apontando para um caractere que    */
      /* no  alfabtico  e o resultado de !*str  0. */
   return !*str;
}

int main(void)
{
   char  *s1 = "bola";
   char  *s2 = "bola?";

   printf( "O string \"%s\" %s alfabetico\n", s1,
           EhStringAlfabetico(s1) ? "e'" : "nao e'" );

   printf( "O string \"%s\" %s alfabetico\n", s2,
           EhStringAlfabetico(s2) ? "e'" : "nao e'" );

   return 0;
}

/****************** Resultado do Programa *****************

O string "bola" e' alfabetico
O string "bola?" nao e' alfabetico

**********************************************************/
