/****
 *
 * Exemplo: Funo strtod()
 *
 * Seo: 8.8.2
 *
 ****/

#include <stdio.h>   /* printf() */
#include <stdlib.h>  /* strtod() */

/****
 *
 * ApresentaConversaoEmDouble(): Converte um string em double
 *                               usando strtod() e exibe o
 *                               resultado na tela
 *
 * Parmetros: str (entrada) - string que ser convertido
 *
 * Retorno: Nada
 *
 ****/
void ApresentaConversaoEmDouble(const char *str)
{
   double      d;
   char       *p; /* Apontar para o caractere */
                  /* no qual a converso parou */

      /* Tenta efetuar a converso do string em double */
   d = strtod(str, &p);

      /* Verifica se foi possvel alguma  */
      /* converso e apresenta o resultado */
   if (p != str) { /* Houve converso */
      printf( "\n\t>>> Conversao do string:\n\t    \"%s\""
              "\n\t    em double: %4.3G\n", str, d );

         /* Verifica se restaram caracteres a ser convertidos */
      if (*p) { /* Restaram caracteres */
         printf( "\n\t    Faltou converter os caracteres:\n"
                 "\t    \"%s\"\n", p );
      } else { /* No restaram caracteres */
         printf("\n\t   Todos os caracteres foram convertidos\n");
      }
   } else { /* No houve converso */
      printf( "\n\t>>> Conversao do string:\n\t    \"%s\""
              "\n\t    em double nao foi possivel\n", str );
   }
}

int main(void)
{
   const char *str1 = "1.6E-19",
              *str2 = "2.54cm equivalem a 1 polegada",
              *str3 = "Carga do eletron: 1.6E-19";

   ApresentaConversaoEmDouble(str1);
   ApresentaConversaoEmDouble(str2);
   ApresentaConversaoEmDouble(str3);

   return 0;
}

/****************** Resultado do Programa *****************

        >>> Conversao do string:
            "1.6E-19"
            em double: 1.6E-019

           Todos os caracteres foram convertidos

        >>> Conversao do string:
            "2.54cm equivalem a 1 polegada"
            em double: 2.54

            Faltou converter os caracteres:
            "cm equivalem a 1 polegada"

        >>> Conversao do string:
            "Carga do eletron: 1.6E-19"
            em double nao foi possivel

**********************************************************/
