/****
 *
 * Ttulo: Centralizando Strings na Tela
 *
 * Autor: Ulysses de Oliveira
 *
 * Data de Criao: 23/12/2008
 * ltima modificao: 16/06/2012
 *
 * Descrio: Apresenta strings centralizados na tela
 *
 * Entrada: No h
 *
 * Sada: Strings centralizados na tela
 *
 ****/

#include <stdio.h>   /* putchar() e printf() */
#include <string.h>  /* strlen()             */

   /* Largura de uma tela de texto considerada aqui */
#define LARGURA_PADRAO 60

/****
 *
 * CentralizaString(): Apresenta um string centralizado na tela
 *
 * Parmetros:
 *     string (entrada) - string a ser centralizado
 *     largura (entrada) - largura da linha na qual o string
 *                         ser centralizado
 *
 * Retorno: Nada
 *
 ****/
void CentralizaString(const char *string, int largura)
{
   int tamanhoStr, /* Tamanho do string */
       coluna, /* Conta espaos em branco que devem */
               /* preceder o string na tela         */
       espacosEsquerda; /* Nmero de espaos que devem preceder */
                        /* a escrita  do string na tela         */

   tamanhoStr = strlen(string); /* Calcula o tamanho do string */

      /* Calcula o nmero de espaos que */
      /* devem ser deixados em branco    */
   espacosEsquerda = (largura - tamanhoStr)/2;

      /* Preenche os espaos em branco */
      /* que devem preceder o string   */
   for(coluna = 0; coluna < espacosEsquerda; coluna++) {
      putchar(' ');
   }

      /* Escreve string aps espaos em branco iniciais */
   printf("%s\n", string);
}

/****
 *
 * main(): Testa a funo CentralizaString()
 *
 * Parmetros: Nenhum
 *
 * Retorno: Zero.
 *
 ****/
int main(void)
{
   char str1[] = "Primeira linha de texto";
   char str2[] = "Segunda linha";
   char str3[] = "Terceira e ultima linha de texto";

   CentralizaString(str1, LARGURA_PADRAO);
   CentralizaString(str2, LARGURA_PADRAO);
   CentralizaString(str3, LARGURA_PADRAO);
   CentralizaString("Tchau!", LARGURA_PADRAO);

   return 0;
}

/****************** Resultado do Programa ******************

                  Primeira linha de texto
                       Segunda linha
              Terceira e ultima linha de texto
                           Tchau!

***********************************************************/
