/****
 *
 * Exemplo: Funes com Retorno de Estruturas
 *
 * Seo: 9.5.2
 *
 ****/

#include <stdio.h>   /* Entrada e sada */
#include "leitura.h" /* LeituraFacil    */

#define MAX_NOME 30

typedef  struct  {
            char  nome[MAX_NOME];
            int   dia, mes, ano;
         } tRegistro;

void ExibeRegistro(const tRegistro *ptrRegistro)
{
   printf("Nome: %s\n", ptrRegistro->nome);
   printf( "Nascimento: %d/%d/%d\n",
           ptrRegistro->dia, ptrRegistro->mes, ptrRegistro->ano );
}

tRegistro LeRegistro1(void)
{
   tRegistro registro;

   printf("\nNome (max = %d letras): ", MAX_NOME - 1);
   LeString(registro.nome, MAX_NOME);

   printf("\nDia de nascimento: ");
   registro.dia = LeInteiro();

   printf("\nMes de nascimento: ");
   registro.mes = LeInteiro();

   printf("\nAno de nascimento: ");
   registro.ano = LeInteiro();

   return registro;
}

tRegistro *LeRegistro2(tRegistro *ptrRegistro)
{
   printf("\nNome (max = %d letras): ", MAX_NOME - 1);
   LeString(ptrRegistro->nome, MAX_NOME);

   printf("\nDia de nascimento: ");
   ptrRegistro->dia = LeInteiro();

   printf("\nMes de nascimento: ");
   ptrRegistro->mes = LeInteiro();

   printf("\nAno de nascimento: ");
   ptrRegistro->ano = LeInteiro();

   return ptrRegistro;
}

int main(void)
{
   tRegistro pessoa1, pessoa2, *ptrPessoa;

   pessoa1 = LeRegistro1();

   printf("\n\n***** Dados da primeira pessoa *****\n\n");
   ExibeRegistro(&pessoa1);

   ptrPessoa = LeRegistro2(&pessoa2);

   printf("\n\n***** Dados da segunda pessoa *****\n\n");
   ExibeRegistro(ptrPessoa);

   return 0;
}

/******************* Exemplo de Execuo *******************

Nome (max = 29 letras): Jose da Silva

Dia de nascimento: 25

Mes de nascimento: 12

Ano de nascimento: 1971


***** Dados da primeira pessoa *****

Nome: Jose da Silva
Nascimento: 25/12/1971

Nome (max = 29 letras): Manoel da Silva

Dia de nascimento: 22

Mes de nascimento: 2

Ano de nascimento: 1980


***** Dados da segunda pessoa *****

Nome: Manoel da Silva
Nascimento: 22/2/1980

***********************************************************/
