/****
 *
 * Exemplo: Registros Variantes
 *
 * Seo: 9.7
 *
 ****/

#include <stdio.h>  /* Funo printf() */
#include <stdlib.h> /* Funo exit()   */

typedef union {
           int    unidades;
           double peso;
        } tQuantidade;

typedef struct {
           char        descricao[20];
           double      precoUnitario;
           int         tipoDeQuantidade;
           tQuantidade quantidade;
        } tProduto;

void ExibeProduto(const tProduto* produto)
{
   printf( "\nProduto: %s\tPreco: R$%4.2f\t",
           produto->descricao, produto->precoUnitario );

      /* Verifica qual  o tipo de quantidade (i.e., */
      /* unidades ou peso) antes de apresent-la     */
   if (produto->tipoDeQuantidade == 1) { /* Unidade */
      printf( "Quantidade: %d unidades\n",
              produto->quantidade.unidades );
   } else if (produto->tipoDeQuantidade == 2) { /* Peso */
      printf("Quantidade: %3.2f Kg\n", produto->quantidade.peso);
   } else { /* Desconhecida */
      printf( "\n\nESTE PROGRAMA CONTEM UM ERRO:\n\t"
              "O valor de produto->tipoDeQuantidade\n\t"
              "nao poderia ser %d\n\n",
              produto->tipoDeQuantidade );
      exit(1); /* Aborta voluntariamente o programa */
   }
}

int main(void)
{
   tProduto produto1 = { "Arroz Arboreo", 12.99, 2 };
   tProduto produto2 = { "Coco Verde", 2.50, 1, {2} };
   tProduto produto3 = { "Jaca Dura", 5.49, 3, {1} };

   produto1.quantidade.peso = 1.5;

   ExibeProduto(&produto1);
   ExibeProduto(&produto2);
   ExibeProduto(&produto3);

   return 0;
}

/****************** Resultado do Programa ******************

Produto: Arroz Arboreo Preco: R$12.99 Quantidade: 1.50 Kg

Produto: Coco Verde    Preco: R$2.50  Quantidade: 2 unidades

Produto: Jaca Dura     Preco: R$5.49

ESTE PROGRAMA CONTEM UM ERRO:
        O valor de produto->tipoDeQuantidade
        nao poderia ser 3

***********************************************************/
