/****
 *
 * Ttulo: Tamanho de um Texto Digitado via Teclado
 *
 * Autor: Ulysses de Oliveira
 *
 * Data de Criao: 30/06/2012
 * ltima modificao: 30/06/2012
 *
 * Descrio: Determina quantos caracteres o usurio digita
 *
 * Entrada: Caracteres digitados pelo usurio via teclado
 *
 * Sada: Uma mensagem informando quantos caracteres foram digitados
 *
 ****/

#include <stdio.h>

/****
 *
 * TamanhoTexto(): L e conta caracteres introduzidos via teclado
 *
 * Parmetros: Nenhum
 *
 * Retorno: Nmero de caracteres digitados
 *
 * Observao: O caractere '\n' no  levado em considerao na
 *             contagem, pois um usurio comum teria alguma
 *             dificuldade em entender que [ENTER]  um caractere
 *
 ****/
int TamanhoTexto(void)
{
   int c,        /* Armazena cada caractere lido */
       nCar = 0; /* Armazena o nmero de caracteres lidos */

   c = getchar(); /* L o primeiro caractere */

      /* Enquanto o caractere '\n' no tiver sido lido e   */
      /* getchar() no retornar EOF, l e conta caracteres */
   while (c != '\n' && c != EOF) {
      ++nCar;
      c = getchar();
   }

         /*                                      */
         /* Se desejar incluir '\n' na contagem, */
         /* basta incrementar a varivel nCar    */
         /* neste ponto antes de retornar        */
         /*                                      */

   return nCar;
}

/****
 *
 * main(): Determina quantos caracteres o usurio digita
 *
 * Parmetros: Nenhum
 *
 * Retorno: Zero
 *
 ****/
int main(void)
{
      /* Apresenta o programa */
   printf( "\n\t>>> Este programa permite que o usuario digite"
           "\n\t>>> quantos caracteres desejar e informa o"
           "\n\t>>> numero de caracteres digitados.\n" );

  printf("\nDigite um texto:\n> ");

     /* Chama a funo TamanhoTexto() para ler o texto */
     /* e informa quantos caracteres foram digitados   */
  printf( "\n\t>>> O texto digitado possui %d caracteres\n",
          TamanhoTexto() );

  return 0;
}

/******************* Exemplo de Execuo ******************

        >>> Este programa permite que o usuario digite
        >>> quantos caracteres desejar e informa o
        >>> numero de caracteres digitados.

Digite um texto:
> Pedro de Alcantara Francisco Antonio Joao Carlos Xavier
  de Paula Miguel Rafael Joaquim Jose Gonzaga Pascoal
  Cipriano Serafim de Braganca e Bourbon

        >>> O texto digitado possui 146 caracteres

**********************************************************/
